<?php

namespace app\admin\controller\device;

use app\common\controller\Backend;

/**
 * 充电设备分组管理
 *
 * @icon fa fa-circle-o
 */
class Chargegroup extends Backend
{

    /**
     * Chargegroup模型对象
     * @var \app\admin\model\device\Chargegroup
     */
    protected $model = null;

    public function _initialize()
    {
        parent::_initialize();
        $this->model = new \app\admin\model\device\Chargegroup;
        $this->Chargedevicemodel = new \app\admin\model\device\Chargedevice;

    }



    /**
     * 默认生成的控制器所继承的父类中有index/add/edit/del/multi五个基础方法、destroy/restore/recyclebin三个回收站方法
     * 因此在当前控制器中可不用编写增删改查的代码,除非需要自己控制这部分逻辑
     * 需要将application/admin/library/traits/Backend.php中对应的方法复制到当前控制器,然后进行修改
     */


    /**
     * 查看
     *
     * @return string|Json
     * @throws \think\Exception
     * @throws DbException
     */
    public function index()
    {
        //设置过滤方法
        $this->request->filter(['strip_tags', 'trim']);
        if (false === $this->request->isAjax()) {
            return $this->view->fetch();
        }
        //如果发送的来源是 Selectpage，则转发到 Selectpage
        if ($this->request->request('keyField')) {
            return $this->selectpage();
        }
        [$where, $sort, $order, $offset, $limit] = $this->buildparams();
        $list = $this->model
            ->alias('cg')
            ->field('*,(select count(1) from ycz_charge_device as cd where user_id=0 and authorizestatus=1 and cd.group_id=cg.id) as remain_units')
            ->where($where)
            ->order('remain_units desc')
            ->paginate($limit);
        foreach ($list as $key => $val){
            $list[$key]['remain_units'] = $this->Chargedevicemodel->where(['group_id' =>$val['id'],'authorizestatus' =>1])->count();
        }
        $result = ['total' => $list->total(), 'rows' => $list->items()];
        return json($result);
    }

}
